/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.covert.ReportTemplateCovert
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.service.TemplateService
 *  com.deepexi.scd.common.enums.business.CalculateObjectEnum
 *  com.deepexi.scd.common.extensions.ExNumeric
 *  com.google.api.client.util.Lists
 *  org.apache.commons.collections.CollectionUtils
 */
package com.deepexi.scd.calculate.service.impl.report;

import com.deepexi.scd.calculate.covert.ReportTemplateCovert;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.service.TemplateService;
import com.deepexi.scd.common.enums.business.CalculateObjectEnum;
import com.deepexi.scd.common.extensions.ExNumeric;
import com.google.api.client.util.Lists;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.Maps;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;
import org.apache.commons.collections.CollectionUtils;

public class IndustryReport9998
implements TemplateService {
    private static final String TEMPLATE_NAME = "industryTemplate9998.ftl";
    protected static final Map<String, String> STANDARD_TOTAL_MAP = Maps.newHashMap();
    public static final List<String> EDGE_LIST;
    public static final List<String> CO2_EDGE_LIST;
    public static final List<String> META_LIST;
    public static final String MAIN = "MAIN";
    public static final String ELECTRIC_HEATING_EDGE = "电力热力";
    public static final String INPUT_ELECTRIC = "电力购入输出明细";
    public static final String INPUT_HEATING = "热力购入输出明细";
    public static final String BURNT_MATERIAL = "炼焦原料";
    public static final String BURNT_PRODUCE = "焦炭产出";

    public void exportTemplate(ExportReportLayoutVO exportReportLayoutVO, Map<String, Object> map) {
        List totalList = (List)exportReportLayoutVO.getTotalMap().get("TOTAL");
        List all = (List)exportReportLayoutVO.getTableMap().get("ALL");
        List targetTableList = (List)exportReportLayoutVO.getTableMap().get("AGGREGATION_TARGET_TABLE");
        List<CalculateReportLayoutTotalVO> mainTotals = this.getMain(totalList);
        ArrayList newTotalList = Lists.newArrayList();
        newTotalList.addAll(this.getEdgeList(totalList));
        newTotalList.addAll(this.getMetaList(totalList));
        newTotalList.addAll(this.getCo2EdgeList(totalList));
        newTotalList.addAll(this.getTableList(totalList));
        map.put("mainTotals", mainTotals);
        map.put("totals", newTotalList);
        map.put("annexedTable2", this.getAnnexedTable2(targetTableList));
        map.put("annexedTable3", this.getAnnexedTable3(all));
        map.put("annexedTable4", this.getAnnexedTable4(targetTableList));
        map.put("annexedTable5", this.getAnnexedTable5(all));
        map.put("annexedTable6", this.getAnnexedTable6(all));
        map.put("annexedTable7", this.getAnnexedTable7(all));
        map.put("annexedTable8", this.getAnnexedTable8(all));
        map.put("annexedTable9", this.getAnnexedTable9(all));
        map.put("annexedTable10", this.getAnnexedTable10(all));
        map.put("list", exportReportLayoutVO);
        map.put("tplName", TEMPLATE_NAME);
    }

    public String getTemplateName() {
        return TEMPLATE_NAME;
    }

    private List<CalculateReportLayoutTotalVO> getMain(List<CalculateReportLayoutTotalVO> totalList) {
        ArrayList result = Lists.newArrayList();
        Optional<CalculateReportLayoutTotalVO> mainOption = totalList.stream().filter(item -> MAIN.equals(item.getTotalType())).findFirst();
        Optional<CalculateReportLayoutTotalVO> electricHeatingOption = totalList.stream().filter(item -> CalculateObjectEnum.EDGE.name().equals(item.getTotalType()) && item.getTotalName().contains(ELECTRIC_HEATING_EDGE)).findFirst();
        BigDecimal mainCount = mainOption.isPresent() ? mainOption.get().getTotalValue() : BigDecimal.ZERO;
        BigDecimal electricHeatingCount = electricHeatingOption.isPresent() ? electricHeatingOption.get().getTotalValue() : BigDecimal.ZERO;
        CalculateReportLayoutTotalVO allCountTotal = new CalculateReportLayoutTotalVO();
        allCountTotal.setTotalName("包括净购入电力和热力隐含的CO₂排放");
        allCountTotal.setTotalValueStr(ExNumeric.stepFormatValue((BigDecimal)mainCount, (Integer)2));
        CalculateReportLayoutTotalVO electricHeatingCountTotal = new CalculateReportLayoutTotalVO();
        electricHeatingCountTotal.setTotalName("不包括净购入电力和热力隐含的CO₂排放");
        electricHeatingCountTotal.setTotalValueStr(ExNumeric.stepFormatValue((BigDecimal)mainCount.subtract(electricHeatingCount), (Integer)2));
        result.add(electricHeatingCountTotal);
        result.add(allCountTotal);
        return result;
    }

    private List<CalculateReportLayoutTotalVO> getEdgeList(List<CalculateReportLayoutTotalVO> totalList) {
        List edgeObjectsList = totalList.stream().filter(item -> CalculateObjectEnum.EDGE.name().equals(item.getTotalType()) && EDGE_LIST.contains(item.getTotalName())).collect(Collectors.toList());
        return ReportTemplateCovert.covertTotalList((String)CalculateObjectEnum.EDGE.name(), EDGE_LIST, STANDARD_TOTAL_MAP, edgeObjectsList);
    }

    private List<CalculateReportLayoutTotalVO> getCo2EdgeList(List<CalculateReportLayoutTotalVO> totalList) {
        List edgeObjectsList = totalList.stream().filter(item -> CalculateObjectEnum.EDGE.name().equals(item.getTotalType()) && CO2_EDGE_LIST.contains(item.getTotalName())).collect(Collectors.toList());
        return ReportTemplateCovert.covertTotalList((String)CalculateObjectEnum.EDGE.name(), CO2_EDGE_LIST, STANDARD_TOTAL_MAP, edgeObjectsList);
    }

    private List<CalculateReportLayoutTotalVO> getMetaList(List<CalculateReportLayoutTotalVO> totalList) {
        List tableObjectsList = totalList.stream().filter(item -> CalculateObjectEnum.META.name().equals(item.getTotalType()) && META_LIST.contains(item.getTotalName())).collect(Collectors.toList());
        return ReportTemplateCovert.covertTotalList((String)CalculateObjectEnum.META.name(), META_LIST, STANDARD_TOTAL_MAP, tableObjectsList);
    }

    private List<CalculateReportLayoutTotalVO> getTableList(List<CalculateReportLayoutTotalVO> totalList) {
        Optional<CalculateReportLayoutTotalVO> inputElectric = totalList.stream().filter(item -> CalculateObjectEnum.TABLE.name().equals(item.getTotalType()) && item.getTotalName().contains(INPUT_ELECTRIC)).findFirst();
        Optional<CalculateReportLayoutTotalVO> inputHeating = totalList.stream().filter(item -> CalculateObjectEnum.TABLE.name().equals(item.getTotalType()) && item.getTotalName().contains(INPUT_HEATING)).findFirst();
        String inputElectricSum = inputElectric.isPresent() ? inputElectric.get().getTotalValueStr() : "0";
        String inputHeatingSum = inputHeating.isPresent() ? inputHeating.get().getTotalValueStr() : "0";
        CalculateReportLayoutTotalVO electric = new CalculateReportLayoutTotalVO();
        electric.setTotalValueStr(ExNumeric.stepFormatValue((String)inputElectricSum, (Integer)2));
        electric.setTotalName("净购入电力隐含的CO₂排放");
        CalculateReportLayoutTotalVO heating = new CalculateReportLayoutTotalVO();
        heating.setTotalValueStr(ExNumeric.stepFormatValue((String)inputHeatingSum, (Integer)2));
        heating.setTotalName("净购入热力隐含的CO₂排放");
        ArrayList result = Lists.newArrayList();
        result.add(electric);
        result.add(heating);
        return result;
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable2(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("化石燃料燃烧"), ImmutableList.of("焦炉燃烧室燃料燃烧"), ImmutableList.of("常规机焦炉（半焦炉）"), (String)"平均低位发热量", (String)"单位热值含碳量", (String)"含碳量计算结果");
        if (CollectionUtils.isEmpty((Collection)tableItems)) {
            return Lists.newArrayList();
        }
        return ReportTemplateCovert.getTarget((CalculateReportLayoutObjectVO)((CalculateReportLayoutObjectVO)tableItems.get(0)));
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable3(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("化石燃料燃烧"), ImmutableList.of("焦炉燃烧室燃料燃烧-热回收焦炉"), ImmutableList.of(BURNT_MATERIAL, BURNT_PRODUCE), (String)"平均低位发热量", (String)"单位热值含碳量", (String)"含碳量计算结果");
        tableItems.forEach(item -> {
            if (BURNT_MATERIAL.equals(item.getObjectName())) {
                item.setObjectName("进入热回收焦炉的碳");
            }
            if (BURNT_PRODUCE.equals(item.getObjectName())) {
                item.setObjectName("输出热回收焦炉的碳");
            }
        });
        return tableItems;
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable4(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("化石燃料燃烧"), ImmutableList.of("其它燃烧设施"), ImmutableList.of("其它燃烧设施"), (String)"平均低位发热量", (String)"单位热值含碳量", (String)"含碳量计算结果");
        if (CollectionUtils.isEmpty((Collection)tableItems)) {
            return Lists.newArrayList();
        }
        return ReportTemplateCovert.getTarget((CalculateReportLayoutObjectVO)((CalculateReportLayoutObjectVO)tableItems.get(0)));
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable5(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("炼焦过程二氧化碳排放"), ImmutableList.of(BURNT_MATERIAL, BURNT_PRODUCE, "焦炉煤气回收"), null, null, null);
        HashMap<String, ImmutableList<String>> aggregationMap = Maps.newHashMap();
        aggregationMap.put("进入炭化室的碳", ImmutableList.of(BURNT_MATERIAL));
        aggregationMap.put("输出炭化室的碳", ImmutableList.of(BURNT_PRODUCE, "焦炉煤气回收"));
        return ReportTemplateCovert.aggregationTable(aggregationMap, (List)tableItems);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable6(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("焦炉煤气制化工产品"), ImmutableList.of("焦炉煤气制化-原材料排放", "焦炉煤气制化-含碳产品", "焦炉煤气制化-含碳废物"), null, null, null);
        HashMap<String, ImmutableList<String>> aggregationMap = Maps.newHashMap();
        aggregationMap.put("碳输入", ImmutableList.of("焦炉煤气制化-原材料排放"));
        aggregationMap.put("碳输出", ImmutableList.of("焦炉煤气制化-含碳产品", "焦炉煤气制化-含碳废物"));
        return ReportTemplateCovert.aggregationTable(aggregationMap, (List)tableItems);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable7(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("煤焦油加工生产"), ImmutableList.of("煤焦油加工生产-原材料排放", "煤焦油加工生产-含碳产品", "煤焦油加工生产-含碳废物"), null, null, null);
        HashMap<String, ImmutableList<String>> aggregationMap = Maps.newHashMap();
        aggregationMap.put("碳输入", ImmutableList.of("煤焦油加工生产-原材料排放"));
        aggregationMap.put("碳输出", ImmutableList.of("煤焦油加工生产-含碳产品", "煤焦油加工生产-含碳废物"));
        return ReportTemplateCovert.aggregationTable(aggregationMap, (List)tableItems);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable8(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("苯加工精制生产"), ImmutableList.of("苯加工精制生产-原材料排放", "苯加工精制生产-含碳产品", "苯加工精制生产-含碳废物"), null, null, null);
        HashMap<String, ImmutableList<String>> aggregationMap = Maps.newHashMap();
        aggregationMap.put("碳输入", ImmutableList.of("苯加工精制生产-原材料排放"));
        aggregationMap.put("碳输出", ImmutableList.of("苯加工精制生产-含碳产品", "苯加工精制生产-含碳废物"));
        return ReportTemplateCovert.aggregationTable(aggregationMap, (List)tableItems);
    }

    private List<CalculateLayoutItemValueVO> getAnnexedTable9(List<CalculateReportLayoutObjectVO> all) {
        List filterItem = ReportTemplateCovert.getFilterItem(all, ImmutableList.of("回收扣除"), ImmutableList.of("气体回收"), ImmutableList.of("二氧化碳回收"));
        return ReportTemplateCovert.valueCodeTotal((List)filterItem);
    }

    private List<CalculateLayoutItemVO> getAnnexedTable10(List<CalculateReportLayoutObjectVO> all) {
        List filterItem = ReportTemplateCovert.getFilterItem(all, ImmutableList.of(ELECTRIC_HEATING_EDGE), ImmutableList.of("电力热力明细"), ImmutableList.of(INPUT_ELECTRIC, INPUT_HEATING));
        ReportTemplateCovert.calculate((List)filterItem, (String)"购入量", (String)"输出量", (String)"净购入量", (String)"SUBTRACT");
        return filterItem;
    }

    static {
        STANDARD_TOTAL_MAP.put("化石燃料燃烧排放量", "燃料燃烧CO₂排放");
        STANDARD_TOTAL_MAP.put("回收扣除排放量", "CO₂回收利用量");
        STANDARD_TOTAL_MAP.put("炼焦过程二氧化碳排放排放量", "炼焦过程的CO₂排放");
        STANDARD_TOTAL_MAP.put("焦炉煤气制化工产品排放量", "焦炉煤气制化工产品生产过程的CO₂排放");
        STANDARD_TOTAL_MAP.put("煤焦油加工生产排放量", "煤焦油加工生产过程CO₂排放");
        STANDARD_TOTAL_MAP.put("苯加工精制生产排放量", "苯加工精制生产过程CO₂排放");
        EDGE_LIST = ImmutableList.of("化石燃料燃烧排放量");
        CO2_EDGE_LIST = ImmutableList.of("回收扣除排放量");
        META_LIST = ImmutableList.of("炼焦过程二氧化碳排放排放量", "焦炉煤气制化工产品排放量", "煤焦油加工生产排放量", "苯加工精制生产排放量");
    }
}

